#ifndef ENTITY_H
#define ENTITY_H

#define MAX_MAP_ENTITIES 1024

typedef struct
{
	epair_t *epairs;
	int index;
} entity_t;

extern int num_entities;
extern entity_t entities[MAX_MAP_ENTITIES];

#define MAX_REMOVE_ENTITIES 200
extern char *rements[MAX_REMOVE_ENTITIES];
extern int num_rements;

bool ParseEntity(void);
void Precache(entity_t *ent);
void RemoveEntities();
extern hudtextparms_t ent_tparms;
void EntityOrigin(int x,int y,int z);
void EntityBox(Vector mins, Vector maxs, Vector origin);
void ShowEntity(entity_t *ent);
char *_strlwr(char *src);
int AddEntity(entity_t *ent);
void LoadEntities();
#endif
