#include "extdll.h"
#include <meta_api.h> // of course
#include "enginecallback.h"
#include "sdk_util.h"
#include "cbase.h"
#include "const.h"
#include "weaponinfo.h"
#include "progdefs.h"
#include "scriplib.h"
#include "axn_plugin.h"
#include "cstrike.h"
#include "entity.h"

#include "usrmsg.h"



int gmsgCurWeapon;
int gmsgDamage;
int gmsgStatusText;
int gmsgScreenShake;
int gmsgScreenFade;
int gmsgWeaponList;
int gmsgHudText;
int gmsgSayText;

int Weapons[32];


pfnMsgFunc MsgFunc=NULL;

bool MsgFunc_Void(void *value)
{
	return false;
}

bool MsgFunc_CurWeapon(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	static int id,clip=0;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==2)
	{
		id=*(int *)value;
	}
	else if(g_msg_index==3)
	{
		clip=*(int *)value;
	}
	else if(g_msg_index==MSGEND)
	{
		int tracer=axn_tracer->value;
		if(tracer>0&&IsAlive(pEntity)&&g_PlayerInfo[index].curweap.id==id&&(Weapons[id]==0||Weapons[id]==1)&&clip<g_PlayerInfo[index].curweap.clip)
		{
			TraceResult tr;
			Vector v_angle=pEntity->v.v_angle;
			if(v_angle.y>180)
				v_angle.y-=360;
			if(v_angle.x>180)
				v_angle.x-=360;
			UTIL_MakeVectors(v_angle);
			Vector vecDir=gpGlobals->v_forward;
			Vector start=pEntity->v.origin + pEntity->v.view_ofs;
			Vector end=start+vecDir*8192;
			UTIL_TraceLine(start, end, dont_ignore_monsters, pEntity->v.pContainingEntity, &tr);
			end=tr.vecEndPos;
			if(tracer==1)
			{
				MESSAGE_BEGIN(MSG_PAS, SVC_TEMPENTITY,start);
					WRITE_BYTE(TE_TRACER);
					WRITE_COORD(start.x);
					WRITE_COORD(start.y);
					WRITE_COORD(start.z);
					WRITE_COORD(end.x);
					WRITE_COORD(end.y);
					WRITE_COORD(end.z);
				MESSAGE_END();
			}
			else if(tracer==2)
			{
				MESSAGE_BEGIN(MSG_SPEC, SVC_TEMPENTITY,start);
					WRITE_BYTE(TE_TRACER);
					WRITE_COORD(start.x);
					WRITE_COORD(start.y);
					WRITE_COORD(start.z);
					WRITE_COORD(end.x);
					WRITE_COORD(end.y);
					WRITE_COORD(end.z);
				MESSAGE_END();
			}
		}
		g_PlayerInfo[index].curweap.id=id;
		g_PlayerInfo[index].curweap.clip=clip;
	}
	return false;
}

bool MsgFunc_Damage(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	static Vector origin;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==4)
	{
		origin.x=*(float *)value;
	}
	else if(g_msg_index==5)
	{
		origin.y=*(float *)value;
	}
	else if(g_msg_index==6)
	{
		origin.z=*(float *)value;
	}
	else if(g_msg_index==MSGEND)
	{
		Vector impact=(pEntity->v.origin-origin).Normalize()*pEntity->v.dmg_take*axn_damageimpact->value;
		pEntity->v.velocity=pEntity->v.velocity+impact;
	}
	return false;
}

bool MsgFunc_ScreenFade(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==2)
	{
		int holdTime=*(int *)value;
		*(int *)value=holdTime*axn_flashtime->value;
		return true;
	}
	return false;
}
bool MsgFunc_StatusText(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==2)
	{
		if(IsAlive(pEntity)&&axn_statustext->value>0)
		{
			char *string=(char *)value;
			strcpy(string,"");
			return true;
		}
	}
	return false;
}

bool MsgFunc_WeaponList(void *value)
{
	static int slot=0;
	static int id=0;
	if(g_msg_index==6)
	{
		slot=*(int *)value;
	}
	else if(g_msg_index==8)
	{
		id=*(int *)value;
		Weapons[id]=slot;
	}
	return false;
}
